osl::move_probability::CoverFork Class Reference

`#include <feature.h>`

Inheritance diagram for osl::move_probability::CoverFork:

## Public Types

enum | { DIM = PTYPE_SIZE * PTYPE_SIZE * PTYPE_SIZE }

## Public Member Functions

| CoverFork ()
double | match (const StateInfo &si, const MoveInfo &mi, int offset, const double *w) const
Public Member Functions inherited from osl::move_probability::Feature
| Feature (std::string n, size_t d)
virtual | ~Feature ()
std::string | name () const
size_t | dimension () const

## Static Public Member Functions

static bool | defending (const NumEffectState &state, Move move, Square target)
Static Public Member Functions inherited from osl::move_probability::Feature
static int | classifyEffect9 (const NumEffectState &state, Player player, Square to)

## Detailed Description

Definition at line 1532 of file move_probability/feature.h.

## Member Enumeration Documentation

## anonymous enum

anonymous enum

Enumerator
DIM |

Definition at line 1535 of file move_probability/feature.h.

## Constructor & Destructor Documentation

## CoverFork()

osl::move_probability::CoverFork::CoverFork | ( |  | ) |

inline

Definition at line 1538 of file move_probability/feature.h.

References DIM, and osl::move_probability::Feature::Feature().

## Member Function Documentation

## defending()

bool osl::move_probability::CoverFork::defending | ( | const NumEffectState & | state,
|  | Move | move,
|  | Square | target )

inline static

Definition at line 1541 of file move_probability/feature.h.

References osl::alt(), osl::Board_Table, osl::NumEffectState::countEffect(), osl::NumEffectState::findCheapAttack(), osl::NumEffectState::hasEffectIf(), osl::Move::isDrop(), osl::Move::ptypeO(), osl::Piece::square(), osl::Move::to(), osl::SimpleState::turn(), and osl::Offset::zero().

Referenced by match().

## match()

double osl::move_probability::CoverFork::match | ( | const StateInfo & | si,
|  | const MoveInfo & | mi,
|  | int | offset,
|  | const double * | w ) const

inline virtual

Implements osl::move_probability::Feature.

Definition at line 1554 of file move_probability/feature.h.

References osl::alt(), osl::PieceMask::any(), osl::PieceMask::clearBit(), defending(), osl::NumEffectState::effectedMask(), osl::move_probability::MoveInfo::move, osl::PAWN, osl::SimpleState::pieceOf(), osl::NumEffectState::piecesOnBoard(), osl::move_probability::MoveInfo::player, osl::Move::ptype(), osl::Piece::ptype(), osl::PTYPE_SIZE, osl::Piece::square(), osl::move_probability::StateInfo::state, and osl::container::PieceMask64::takeOneBit().

The documentation for this class was generated from the following file:

- move_probability/feature.h